#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_width1 1
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color3 DimGray
#property indicator_style3 1
#property indicator_color4 DimGray
#property indicator_style4 1

extern bool Show_DailyHighLow  = true;
extern bool Show_OpenDaily  = true;
extern bool Show_DailyPivot = true;
extern int  Width            = 2;
extern int  TimeZone        = 0;
extern int BarsCount=900;

double OpenDaily[], PivotArray[], YH[], YL[];
int i, limit;
datetime BT[];
string name;
double YesterdayHigh[50], YesterdayLow[50], YesterdayClose[50], P;

int init() {
   if(Show_OpenDaily)    {  SetIndexStyle(0, DRAW_LINE);   SetIndexBuffer(0, OpenDaily);   SetIndexLabel(0, "OpenDaily");   SetIndexEmptyValue(0, 0.0);  }
   if(Show_DailyPivot)   {  SetIndexStyle(1, DRAW_LINE);   SetIndexBuffer(1,PivotArray);   SetIndexLabel(1, "DailyPivot");  }
   if(Show_DailyHighLow) { 
     SetIndexStyle(2, DRAW_LINE);   SetIndexBuffer(2, YH);      SetIndexLabel(2, "YesterdayHigh");
     SetIndexStyle(3, DRAW_LINE);   SetIndexBuffer(3, YL);      SetIndexLabel(3, "YesterdayLow");
   }
   return (0);
}

int deinit() {  return (0);  }

int start() {
    ArrayCopySeries(BT, MODE_TIME);
    ArrayCopySeries(YesterdayHigh, MODE_HIGH, Symbol(), PERIOD_D1);
    ArrayCopySeries(YesterdayLow, MODE_LOW, Symbol(), PERIOD_D1);
    ArrayCopySeries(YesterdayClose, MODE_CLOSE, Symbol(), PERIOD_D1);
    int od = 0, dd = 0;
    double Pivot;
    int counted_bars = IndicatorCounted();
    if (counted_bars > 0) counted_bars--;
    limit = Bars - counted_bars;

    for(i = 0; i <= BarsCount; i++) {
      if(TimeDay(BT[i]) != od) {
        dd++;
        Pivot = (YesterdayHigh[dd] + YesterdayLow[dd] + YesterdayClose[dd])/3;
        od = TimeDay(BT[i]);
      }
      PivotArray[i] = Pivot;
      YH[i]=YesterdayHigh[dd];  YL[i]=YesterdayLow[dd];
    }
    for(i=ArraySize(PivotArray)-2; i>=0; i--) {
      if(PivotArray[i] != PivotArray[i+1])  {  PivotArray[i+1]=EMPTY_VALUE;  YH[i]=EMPTY_VALUE;  YL[i]=EMPTY_VALUE;  }
    }
    for(i = BarsCount; i >=0 ; i--) {
      OpenDaily[i] = 0;
      if(TimeDay(Time[i]-TimeZone)!=TimeDay(Time[i+1]-TimeZone)) { OpenDaily[i] = Open[i];  OpenDaily[i + 1] = 0;  }
      else OpenDaily[i] = OpenDaily[i + 1];
    }
   return (0);
}


