//+------------------------------------------------------------------+ 
// FXi 3 Semafor
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
//---- input parameters 
extern string Font_style = "FixedSys";
extern int corner = 3;
extern int X_distance = 3;
extern int Y_distance = 6;

int Period1=233; 
int Stp=1;
int Dev=1; 
color LabelColor = Black;
int BarsCount = 1000;
#define OBJ_NAME "SpreadIndikatorObj"
//---- buffers 
double FP_BuferUp[], FP_BuferDn[]; 
//+------------------------------------------------------------------+  
string symbol;  
int    digits, period, key  ; 
//+------------------------------------------------------------------+ 
int init()   { 
   period       = Period() ;     
   symbol       =  Symbol() ;
   digits       =  Digits ;  
   key=0;
   IndicatorDigits(5); 
//+------------------------------------------------------------------+   
   if (Period1>0)   {
     SetIndexBuffer(0,FP_BuferUp);   SetIndexStyle(0,DRAW_NONE, 0, 3, clrBlue);  SetIndexArrow(0, 82);
     SetIndexBuffer(1,FP_BuferDn);   SetIndexStyle(1,DRAW_NONE, 0, 3, clrRed);   SetIndexArrow(1, 82);
   }   
   return(0); 
  } 
//+------------------------------------------------------------------+ 
int deinit(){   ObjectDelete(OBJ_NAME);     return(0);  }
//+------------------------------------------------------------------+ 
int start()   { 
  if (Period1>0) CountZZ(FP_BuferUp,FP_BuferDn,Period1,Dev,Stp);
  if(key!=Time[0])  { 
    for(int i=0; i<1000; i++)  {
      if(FP_BuferDn[i]>0) {  LabelColor = clrRed;  break;  }
      if(FP_BuferUp[i]>0) {  LabelColor = clrLime; break;  }
    }
    key=Time[0];
  }    
  ShowSpread(LabelColor);
   return(0);
}

void ShowSpread(color Color) {
   static double spread;
   spread = MarketInfo(Symbol(), MODE_SPREAD)/10 ;
   DrawSpreadOnChart(spread, Color);
}

void DrawSpreadOnChart(double spread, color Col)  {
   string s = DoubleToStr(spread, 1)+" pips";
   if(ObjectFind(OBJ_NAME) < 0)   {
      ObjectCreate(OBJ_NAME, OBJ_LABEL, 0, 0, 0);
      ObjectSet(OBJ_NAME, OBJPROP_CORNER, corner);
      ObjectSet(OBJ_NAME, OBJPROP_YDISTANCE, Y_distance);
      ObjectSet(OBJ_NAME, OBJPROP_XDISTANCE, X_distance);
      ObjectSetText(OBJ_NAME, s, 12, Font_style, Col);
   }
   ObjectSetText(OBJ_NAME, s, 12, Font_style, Col);
   WindowRedraw();
}

//+------------------------------------------------------------------+   
int CountZZ( double& Up[], double& Dn[], int ExtDepth, int ExtDeviation, int ExtBackstep )
  {
   int    shift, back,lasthighpos,lastlowpos, limit;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;
   limit=Bars-ExtDepth;
   if(limit>BarsCount) limit=BarsCount;   
   for(shift=limit; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=00;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=00;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=Up[shift+back];
               if((res!=0)&&(res>val)) Up[shift+back]=00; 
              }
           }
        } 
        
          Up[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=00;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=00;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=Dn[shift+back];
               if((res!=0)&&(res<val)) Dn[shift+back]=00; 
              } 
           }
        }
      Dn[shift]=val;
     }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=limit; shift>=0; shift--)
     {
      curlow=Up[shift];
      curhigh=Dn[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) Dn[lasthighpos]=0;
            else Dn[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) Up[lastlowpos]=0;
            else Up[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=limit; shift>=0; shift--)
     {
      if(shift>=limit) Up[shift]=00;
      else
        {
         res=Dn[shift];
         if(res!=00) Dn[shift]=res;
        }
     }
   return(0);
 }
//+------------------------------------------------------------------+   
