//+----------------------------------------------------------------------------+
//|                                                              i-Profit.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  12.05.2008  :                                                    |
//|              -                                               |
//|              -                                             |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"
#property indicator_chart_window

//-------    ----------------------------------------+
extern int   eiPercent = 1;            //    :
                                       //  0 -  
                                       //  1 -    
extern int   eiOffsetY = 80;           //    
extern int   eiStepY   = 20;           //     
extern int   eiX1Row   = 3;            //  X  
extern int   eiX2Row   = 130;          //  X  
extern int   eiX3Row   = 170;          //  X  
extern color ecText    = Gold;         //  
extern color ecProfit  = Lime;        //  
extern color ecLoss    = Red;    //  

//+----------------------------------------------------------------------------+
void init() {  DeleteObjects(); }
//+----------------------------------------------------------------------------+
void deinit() {  DeleteObjects();  }
//+----------------------------------------------------------------------------+
void start() {
  datetime d0;
  d0=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));

  double tb=AccountBalance(), tp=AccountProfit();
  double p0=GetProfitFromDateInCurrency("", -1, -1, d0);

  string st;
  switch (eiPercent) {
    case 0 :         st=""          ; break;
    case 1 : tb-=p0; st="  "     ; break;
  }
  double tr=tp*100/tb;
  double r0=p0*100/tb;
  
  SetLabel("iProfit11", " ", ecText, eiX1Row, eiOffsetY);
  SetLabel("iProfit21", "  ", ecText, eiX1Row, eiOffsetY+eiStepY);

  SetLabel("iProfit12", DoubleToStr(tp, 2), ColorOnSign(tp), eiX2Row, eiOffsetY);
  SetLabel("iProfit22", DoubleToStr(p0, 2), ColorOnSign(p0), eiX2Row, eiOffsetY+eiStepY);

  SetLabel("iProfit13", DoubleToStr(tr, 2)+" %", ColorOnSign(tr), eiX3Row, eiOffsetY);
  SetLabel("iProfit23", DoubleToStr(r0, 2)+" %", ColorOnSign(r0), eiX3Row, eiOffsetY+eiStepY);
}
//+----------------------------------------------------------------------------+
//|                                                  |
//+----------------------------------------------------------------------------+
color ColorOnSign(double nu) {
  color lcColor=ecText;

  if (nu>0) lcColor=ecProfit;
  if (nu<0) lcColor=ecLoss;

  return(lcColor);
}
//+----------------------------------------------------------------------------+
//|   .                                                        |
//+----------------------------------------------------------------------------+
void DeleteObjects() {
  string st="iProfit";
  int    i, j;

  for (i=0; i<3; i++) {
    for (j=1; j<4; j++) ObjectDelete(st+i+j);
  }
}
//+----------------------------------------------------------------------------+
//|   :                        |
//|                                            |
//+----------------------------------------------------------------------------+
double GetProfitFromDateInCurrency(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0;
  int    i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (dt<OrderCloseTime()) {
              p+=OrderProfit()+OrderCommission()+OrderSwap();
            }
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+
//|   :                                         |
//+----------------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx, fs);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}
//+----------------------------------------------------------------------------+

